/*analog-array@1.0.0#src/analog-array*/
define('analog-array', ['exports'], function (exports) {
    'use strict';
    Object.defineProperty(exports, '__esModule', { value: true });
    var getter = function getter(target, prop, receiver) {
        var propFloat = parseFloat(prop);
        if (!isNaN(propFloat)) {
            if (propFloat < 0) {
                return target[0];
            }
            var leftIndex = ~~propFloat;
            var lastIndex = target.length - 1;
            if (leftIndex >= lastIndex) {
                return target[lastIndex];
            }
            if (propFloat === leftIndex) {
                return target[propFloat];
            }
            return this.slide(target[leftIndex], target[leftIndex + 1], propFloat - leftIndex);
        } else {
            return Reflect.get(target, prop, receiver);
        }
    };
    var setter = function setter(target, prop, value, receiver) {
        if (prop === 'slide') {
            this.slide = value;
            return value;
        }
        return Reflect.set(target, prop, value, receiver);
    };
    function AnalogArray(array, slide) {
        this.array = array || [];
        this.slide = slide || AnalogArray.slideNumber;
        return new Proxy(this.array, {
            get: getter.bind(this),
            set: setter.bind(this)
        });
    }
    Object.assign(AnalogArray, {
        slideNumber: function slideNumber(from, to, amount) {
            return (to - from) * amount + from;
        },
        slideByte: function slideByte(from, to, amount) {
            var slid = AnalogArray.slideNumber(from & 255, to & 255, amount);
            return Math.round(Math.min(Math.max(slid, 0), 255));
        },
        slideColor: function slideColor(from, to, amount) {
            var sb = AnalogArray.slideByte;
            var fromLen = from.length;
            var color1 = parseInt(from.replace('#', ''), 16);
            var color2 = parseInt(to.replace('#', ''), 16);
            var res = sb(color1, color2, amount) | sb(color1 >>> 8, color2 >>> 8, amount) << 8 | sb(color1 >>> 16, color2 >>> 16, amount) << 16 | (fromLen > 7 ? sb(color1 >>> 24, color2 >>> 24, amount) << 24 : 0);
            var resStr = (res >>> 0).toString(16).padStart((fromLen | 1) ^ 1, '0');
            return fromLen & 1 ? '#' + resStr : resStr;
        }
    });
    exports.AnalogArray = AnalogArray;
    exports.default = AnalogArray;
});